//+------------------------------------------------------------------+
//|                                                   COHFractal.mq4 |
//|                                             by Francesco Marasco |
//|                                              Based on TRO_MM_COH |
//|         Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne |
//+------------------------------------------------------------------+
#property copyright "Francesco Marasco"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 RoyalBlue
#property indicator_color2 DeepPink

double ExtHBuffer1[];
double ExtHBuffer2[];

double  myUpper, myLower, open, high, low, close, close1, close2 ;
bool Neither, COHup, COHdn; 


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2); 
   SetIndexStyle(0,DRAW_ARROW,0,4); 
   SetIndexArrow(0, 74); 
   SetIndexBuffer(0,ExtHBuffer1); 
   SetIndexStyle(1,DRAW_ARROW,0,4); 
   SetIndexBuffer(1,ExtHBuffer2); 
   SetIndexArrow(1, 76); 
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   int    i, limit;
   limit = Bars-counted_bars;
   
   for (i=0;i<limit;i++)
   {
      close     = iClose(NULL,0,i+0) ;
      high      = iHigh(NULL,0,i+0) ; 
      low       = iLow(NULL,0,i+0) ;
 
      close1     = iClose(NULL,0,i+1) ; 
      close2     = iClose(NULL,0,i+2) ; 
 
      COHup   = ( close1 < close2 && close > close2 ) ;
      COHdn   = ( close1 > close2 && close < close2 ) ; 

      Neither      = !COHup && !COHdn   ;

      if (!Neither)
      {
         if (COHup)
         {
            ExtHBuffer1[i] = low;
            ExtHBuffer2[i] = 0;
         }
         else
         if (COHdn)
         {
            ExtHBuffer1[i] = 0;
            ExtHBuffer2[i] = high;
         }
      }
   }
   return(0);
}
//+------------------------------------------------------------------+